/* Si realizzi un programma, in linguaggio C, che legge in ingresso 10
numeri interi indicanti laltezza espressa in centimetri dei giocatori
di una squadra di basket e fornisce in output laltezza media e laltezza
del giocatore che pi si discosta dalla media.

Esempio:
Digitare i valori delle 10 altezze:
198  201  188  192  204  200  195  206  197  201
Altezza media:   198.2
Altezza del giocatore che pi si discosta dalla media:  188
*/

#include <stdio.h>

#define DIM 10

void caricaArray(float [], int);
void stampaArray(float [], int);
float media(float [], int);
float abs(float);
float maxScarto(float [], int, float);

int main()
{
	float arr[DIM];
	float mediaa, scart=0;

	caricaArray(arr, DIM);

	stampaArray(arr, DIM);

	mediaa = media(arr, DIM);
	printf("Altezza media: %.2f\n", mediaa);

	scart=maxScarto(arr, DIM, mediaa);
	printf("Altezza del giocatore che piu' si discosta dalla media: %.2f\n", scart);

	return 0;
}


void caricaArray(float vett[], int dim)
{
	int i;
	for(i=0; i<dim; i++){
		printf("Inserire il valore n. %d del'array  ", i+1);
		scanf("%f", &vett[i]);
	}
	printf("\n");
	return;
}

void stampaArray(float vett[], int dim)
{
	int i;
	printf("L'array e':\n");
	for(i=0; i<dim; i++){
		printf("%.0f\t", vett[i]);
	}
	printf("\n");
	return;
}

float media(float vett[], int dim)
{
	int i;
	float tot=0, med=0;
	for(i=0; i<dim; i++){
		tot=tot+vett[i];
	}
	med=tot/dim;
	return med;
}

float maxScarto(float vett[], int dim, float med)
{
	float scarMax=0, valScarMax;
	/*int i=0;
	float scarMax, valScarMax;
	scarMax = abs(med-vett[i]);
	valScarMax = vett[i];
	for(i=1; i<dim; i++){
		if(abs(med-vett[i])>scarMax)*/
	for(int i=0; i<dim; i++){
		if(abs(med-vett[i])>scarMax){
			scarMax=abs(med-vett[i]);
			valScarMax=vett[i];
		}
	}
	return valScarMax;
}


float abs(float scar)
{
if(scar>0)
	return scar;
else
	return -scar;
}
