/*
Al programma fornito, si aggiungano le dichiarazioni, le definizioni e le
chiamate (indicate come commento nel file dato) delle seguenti tre funzioni:
- cambiaPosizioni che ha come parametri formali un array di interi e la sua
  dimensione e che esegue l'inversione della posizione degli elementi
  dell'array secondo le seguenti modalit: il primo elemento si scambia di
  posizione con l'ultimo, il secondo con il penultimo e cosi' via per tutto
  l'array;
- ordinaDecrescente che ha come parametri formali un array di interi e la sua
  dimensione e che effettua l'ordinamento per valori decrescenti dell'array;
- stampa che ha come parametri formali un array di interi e la sua dimensione
  e che produce la stampa a video dei dati presenti nell'array.
*/


#include <stdio.h>
#define DISP 9
#define PARI 8


/* Dichiarazione funzioni */
void cambiaPosizioni(int [], int);
void ordinaDecrescente(int [], int);
void stampaArray(int [], int);

void main(void)
{
   int dati1[DISP]={-3, 44, 12, 0, 23, -2, 8, -12, 3};
   int dati2[PARI]={-3, 44, 12, 0, 23, -2, 8, -12};

   printf("Test1 : l'array iniziale e' il seguente:\n");
   /* Chiamata della funzione stampa */
   stampaArray(dati1, DISP);

   /* Chiamata della funzione cambiaPosizioni */
   cambiaPosizioni(dati1, DISP);
   printf("Test1 : l'array modificato e' il seguente:\n");
   /* Chiamata della funzione stampa */
   stampaArray(dati1, DISP);

   /* Chiamata della funzione ordinaDecrescente */
   ordinaDecrescente(dati1, DISP);
   printf("Test1 : l'array ordinato decrescente e' il seguente:\n");
   /* Chiamata della funzione stampa */
   stampaArray(dati1, DISP);

   printf("\n\n");
   printf("Test2 : l'array iniziale e' il seguente:\n");
   /* Chiamata della funzione stampa */
   stampaArray(dati2, PARI);

   /* Chiamata della funzione cambiaPosizioni */
   cambiaPosizioni(dati2, PARI);
   printf("Test2 : l'array modificato e' il seguente:\n");
   /* Chiamata della funzione stampa */
   stampaArray(dati2, PARI);

   /* Chiamata della funzione ordinaDecrescente */
   ordinaDecrescente(dati2, PARI);
   printf("Test2 : l'array ordinato decrescente e' il seguente:\n");
   /* Chiamata della funzione stampa */
   stampaArray(dati2, PARI);

   return;
}


/* Definizione delle funzioni */
void cambiaPosizioni(int vett[], int dim)
{
   int i, j, temp;
   for(i=0, j=dim-1; i<j; i++, j--)
   {
      temp=vett[j];
      vett[j]=vett[i];
      vett[i]=temp;
   }
   return;
}


void ordinaDecrescente(int vett[], int dim)
{
   int temp;
   for(int i=0; i<dim; i++)
   {
      for(int j=i; j<dim; j++)
      {
         if(vett[i]<vett[j])
         {
            temp=vett[i];
            vett[i]=vett[j];
            vett[j]=temp;
         }
      }
   }
   return;
}


void stampaArray(int vett[], int dim)
{
   printf("L'array e':\n");
   for (int i=0; i<dim; i++)
      printf("%d\t", vett[i]);
   printf("\n");
   return;
}


