/* Si realizzi un programma, in linguaggio C, per fare il calcolo del prodotto
di 2 vettori di dimensione (1,n) e (n,1). Si devono leggere, in ingresso, il
numero n che esprime la dimensione dei  2 vettori (si supponga che n possa valere
al massimo 10) e quindi le 2 sequenze di n numeri interi ognuna delle quali
rappresenta i valori di un singolo vettore.
Si ricorda che il prodotto di due vettori e dato dalla somma dei prodotti degli
elementi corrispondenti.
Si forniscano in output i valori dei 2 vettori ed il risultato del loro prodotto.

Esempio:
dati i vettori (2, 4, 6) e (1, il loro prodotto e : 28.
                            2,
                            3)

Il programma ricevera i seguenti dati in input:
Dimensione vettore:  3
Primo vettore:   2   4   6
Secondo vettore:  1   2   3

e fornira in output:
Dati i vettori
2   4   6
1   2   3
il loro prodotto e:   28
*/

#include <stdio.h>

void caricaArray(int [], int);
void stampaArray(int [], int);
int prodottoArray(int [], int [], int);


int main()
{
   int i, dimen=0;
   int vett1[dimen], vett2[dimen];
   int prod;

   printf("Inserire la dimensione dei 2 vettori:  ");
   scanf("%d", &dimen);

   printf("\nPrimo array:\n");
   caricaArray(vett1, dimen);

   printf("\nIl primo array e':\n");
   stampaArray(vett1, dimen);

   printf("\nSecondo array:\n");
   caricaArray(vett2, dimen);

   printf("\nIl secondo array e':\n");
   stampaArray(vett2, dimen);

   printf("\nIl primo array e':\n");
   stampaArray(vett1, dimen);

   prod=prodottoArray(vett1, vett2, dimen);

   printf("\n\nIl prodotto e' %d\n\n", prod);

   return 0;
}


void caricaArray(int vetto[], int dim)
{
   int i;
   for(i=0; i<dim; i++){
      printf("Inserire il valore n. %d del vettore: ", i+1);
      scanf("%d", &vetto[i]);
   }
   return;
}

void stampaArray(int vett[], int dim)
{
   int i;
   for(i=0; i<dim; i++)
      printf("%d\t", vett[i]);
   return;
}

int prodottoArray(int vettA[], int vettB[], int dim)
{
   int prodotto=0;
   for(int i=0; i<dim; i++)
      {
      prodotto+=(vettA[i]*vettB[i]);
      }
   return prodotto;
}
