/*
Si scriva, in linguaggio C, la funzione datiCrescenti, che, ricevendo in
ingresso un array di dodici interi, un valore iniziale ed un valore finale per
l'indice, verifica se i valori dell'array a partire dall'indice iniziale
e fino all'indice finale sono crescenti, nel qual caso restituisce valore 1
(vero), altrimenti restituisce valore 0 (falso).
Tale funzione inoltre, nel caso in cui i valori interessati risultino essere
crescenti, deve restituire al programma chiamante, facendo uso di un parametro
passato per riferimento, la media degli incrementi fra il valore presente in
una singola cella e quello della cella immediatamente seguente (limitandosi al
periodo indicato dagli indici forniti).
Si scriva inoltre un programma per testare il corretto funzionamento di tale funzione.
*/

#include <stdio.h>
#define DIM 12

int datiCrescenti(int [], int, int, int, float *);
void caricaArray(int [], int);
void stampaArray(int [], int);
float mediaIncrementi(int [], int, int, int);

int main()
{
   int interi[DIM], iniz=0, fine=0, rit;
   float media=5;

   caricaArray(interi, DIM);

   stampaArray(interi, DIM);

   printf("Numero cella da cui iniziare il check?\n");
   scanf("%d", &iniz);
   printf("Numero cella su cui finire il check?\n");
   scanf("%d", &fine);

   rit=datiCrescenti(interi, DIM, iniz, fine, &media);

   if(rit==1)
   {
      printf("\nI valori sono crescenti\n");
      printf("\nLa media degli scarti e' %f\n", media);
   }
   else
      printf("\nI valori non sono crescenti\n");
   //printf("%d", rit);

   return 0;
}

int datiCrescenti(int vett[], int dim, int einf, int esup, float *mediaIncr)
{
   int cont=0;
   /*float tot=0;*/
   for(int i=einf; i<esup; i++)
      if(vett[i]<vett[i+1])
         cont++;
   if(cont==(esup-einf))
   {
      /*for(int i=einf; i<esup; i++)
	     tot=tot+(vett[i+1]-vett[i]);
      printf("\nNum %.2f\n", tot);
	  printf("\nDen %d\n", (esup-einf));
	  *mediaIncr= tot/(esup-einf);*/
  	  *mediaIncr=mediaIncrementi(vett, DIM, einf, esup);
	  return 1;
   }
   else
      return 0;
}

void caricaArray(int vett[], int dim)
{
   printf("Inserire i valori del vettore:\n\n");
   for(int i=0; i<dim; i++)
   {
      printf("Inserire il valore n. %d del vettore:  ", i+1);
	  scanf("%d", &vett[i]);
   }
   printf("\n");
   return;
}

void stampaArray(int vett[], int dim)
{
   printf("\nIl vettore e':\n");
   for(int i=0; i<dim; i++)
   {
      printf("%d\t", vett[i]);
   }
   printf("\n");
   return;
}


float mediaIncrementi(int vett[], int dim , int einf, int esup)
{
   float tot=0, media=0;
   for(int i=einf; i<esup; i++)
      tot=tot+(vett[i+1]-vett[i]);
   //printf("\nNum %.2f\n", tot);
   //printf("\nDen %d\n", (esup-einf));
   media = tot/(esup-einf);
   return media;
}

