/*
Si scriva una funzione, in linguaggio C, che, ricevendo in ingresso un array di
interi, la rispettiva dimensione, un valore iniziale ed un valore finale per
l'indice, se i valori iniziale e finale sono accettabili (cio se sono minori o
uguali alla dimensione dell'array ed il valore iniziale  minore del valore
finale) calcola la media dei valori degli elementi dell'array il cui indice
varia fra il valore iniziale ed il valore finale (entrambi inclusi).
La funzione fornisce come valore di ritorno un intero che sar uguale ad 1 se i
valori forniti per l'indice sono accettabili, 0 altrimenti.
La media calcolata dovr essere restituita al programma chiamante facendo uso
di un parametro passato per riferimento.
Aggiungere inoltre, laddove indicato, le chiamate alla funzione passando i dati
che vengono specificati.
*/

#include <stdio.h>
#define LUNG 10

// DICHIARAZIONE DELLA FUNZIONE (metterla al posto dei puntini)
int med(int [], int, int, int, float *);

void main()
{
	int prova[LUNG] = {7, 12, -4, 6, 8, -6, 2, 11, -9, 15};
	int ok;
	float media;

	// CHIAMATA DELLA FUNZIONE (metterla al posto dei puntini) PASSANDO COME
	// PARAMETRI ATTUALI:
	// L'ARRAY prova, LA SUA DIMENSIONE, VALORE INIZIALE 2, VALORE FINALE 8.
	// AD ok DEVE ESSERE ASSEGNATO IL VALORE DI RITORNO DELLA FUNZIONE ED A
	// media LA MEDIA CALCOLATA DALLA FUNZIONE.
	ok=med(prova, LUNG, 2, 8, &media);

	if (ok)
		printf("Il valore calcolato e': %.2f\n", media);
	else
		printf("I dati forniti non sono accettabili\n");

	return;
}


// DEFINIZIONE DELLA FUNZIONE (metterla al posto dei puntini)
int med(int vett[], int dim, int einf, int esup, float *av)
{
	int i, tot=0;
	if(einf<=dim && esup<=dim && einf<esup){
		for(i=einf; i<=esup; i++)
			tot=tot+vett[i];
		*av=tot/(esup-einf);
		//printf("tot e' %d", tot);
		return 1;
	}
	else
		return 0;
}
