/* Si realizzi un programma che, ciclicamente, legge una parola di massimo
20 caratteri e determina se e' palindroma; il programma termina quando viene
inserita una riga vuota.
Si ricorda che una parola e palindroma se e indifferente leggerla da
sinistra verso destra e da destra verso sinistra.

Esempio:
anna
E palindroma

prova
Non e palindroma
*/

#include <stdio.h>

#define DIM 20
#define TAPPO '\n'

void caricaArray(char[], int, int *);
void stampaArray(char[], int);
void palCheck(char[],int);

int main()
{
   char car[DIM]={0};
   int count=0;

   caricaArray(car, DIM, &count);

   stampaArray(car, count-1);

   palCheck(car, count);

   return 0;
}

void caricaArray(char vett[], int dim, int *count1)
{
   int i, ncell=0;
   char carattere;

   printf("Inserire una parola di massimo 20 caratteri: \n");
   for (i=0, carattere=' '; ((i<dim+1) && (carattere!=TAPPO)) ; i++)
   {
      scanf("%c", &carattere);
      vett[i]=carattere;
      ncell++;
   }
   *count1=ncell;
   printf("\n");

return;
}

void stampaArray(char vett[], int ncell1)
{
   int i;

   printf("\nL'array e': \n");
   for (i=0; i<ncell1; i++)
      printf("%c", vett[i]);
   printf("\n");

   return;
}

void palCheck(char vett[],int dim)
{
   int cont=0;
   for(int i=0, j=(dim-2); i<j; i++, j--)
      if(vett[i]==vett[j])
         cont++;
   if(cont==((dim-1)/2))
      printf("\nPalindroma\n");
   else
      printf("\nNon palindroma\n");
   printf("\nN. celle piene e': %d\n", dim-1);
   printf("\nN. coppie di celle uguali e': %d\n", cont);
}
